//an I_V plotter for power supplies
unsigned long time_interval_ms = 10; // time for each averaged data point
unsigned long time_total_sec = 2; // total time to record data
unsigned long  time_on_ms = 500; // on time for the ramp

float R1 = 9.902e3; // voltage divider resistor
float R2 = 9.903e3;
float R3 = 6.800e3;
float R4 = 3.24e3;
float Rtotal = R1 + R2 + R3 + R4;

//float Vgain=1;
//float Vgain = (R2 + R3 + R4) / Rtotal;
//float Vgain=(R3+R4)/Rtotal;
float Vgain=R4/Rtotal;
//float Vgain=1;

float Rload = 11.05;
//float Rload = 50.5;

float Vref=3.2997;

boolean PLX_flag = 1; // for makerPlot, set this false, set for normal output no headers
boolean print_flag = 1; //tells if we print to serial  port

unsigned long time0_us = 0;
unsigned long time1_us = 0;
unsigned long time2_us = 0;
unsigned long time_total_us = time_total_sec * 1000000;
int chan1_pin = A0;// this is the voltage on supply
int chan2_pin = A1;// this is the current through supply
float chan1_val = 0;
float chan2_val = 0;
float Vmeas;
float Imeas;
float time_data_sec;
unsigned long counter1 = 0;
unsigned long counter2 = 0;
unsigned long time_interval_us = time_interval_ms * 1000;
unsigned long time_on_us = time_on_ms * 1000;


void printData() {
  // this function will print the data to the serial port
  if (PLX_flag == true) {
    Serial.print("DATA, ");
    Serial.print(counter2);
    Serial.print(", ");
    Serial.print(time_data_sec, 3);
    Serial.print(", ");
  }
  Serial.print(Imeas,3);
  Serial.print(", ");
  Serial.println(Vmeas,3);
}

void take2ChanAveData() {
  // take data over average interval
  counter2 = 0;
  chan1_val = 0;
  chan2_val = 0;
  time1_us = micros();

  do {
    chan1_val = analogRead(chan1_pin) + chan1_val;
    chan2_val = analogRead(chan2_pin) + chan2_val;
    counter2 = counter2 + 1;
  } while (micros() < (time0_us + time_interval_us * counter1));

  time_data_sec = ((micros() - time1_us) * 0.5 + time1_us - time0_us) / 1e6;
  chan1_val = chan1_val / counter2;
  chan2_val = chan2_val / counter2;
  Vmeas = chan1_val / 1023 * Vref / Vgain;
  Imeas = chan2_val / 1023 * Vref / Rload;
  if (print_flag == true) printData();
}

void setup() {
  // initialize serial communication
  analogReference(EXTERNAL);
  Serial.begin(56000);
  pinMode(13, OUTPUT);
  pinMode(12, OUTPUT);
  digitalWrite(13, LOW);
  digitalWrite(12, HIGH);
  time0_us = micros(); // start the timer
  //noInterrupts();
  counter1 = 0;

  if (PLX_flag == true) {
    Serial.println("CLEARDATA");
    Serial.println("LABEL,NptsAveraged,Time(sec),Imeas,Vmeas");
  }

}


void loop() {
 time0_us = micros(); // start the timer
 digitalWrite(13, LOW);
  for (counter1 = 1; counter1 <= 5; counter1++) {
    //digitalWrite(13, HIGH);
    take2ChanAveData();
  }

  digitalWrite(13, HIGH);
  do {
    take2ChanAveData();
    counter1 = counter1 + 1;
  } while (micros() < (time0_us + time_on_us));

  digitalWrite(13, LOW);

  do {
    counter1 = counter1 + 1;
    take2ChanAveData();
  } while (micros() < (time0_us + time_total_us));

  while (micros()>0){
  }

}
